/*!
 * Error tracking for Snowplow v4.6.3 (http://bit.ly/sp-js)
 * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
 * Licensed under BSD-3-Clause
 */

"use strict";!function(n,o){"object"==typeof exports&&"undefined"!=typeof module?o(exports):"function"==typeof define&&define.amd?define(["exports"],o):o((n="undefined"!=typeof globalThis?globalThis:n||self).snowplowErrorTracking={})}(this,(function(n){function o(n,o,e){if(e||2===arguments.length)for(var r,t=0,c=o.length;t<c;t++)!r&&t in o||(r||(r=Array.prototype.slice.call(o,0,t)),r[t]=o[t]);return n.concat(r||Array.prototype.slice.call(o))}function e(n,o){return void 0===o&&(o=8192),n&&n.length>o?n.substring(0,o):n}function r(n,o){void 0===o&&(o=Object.keys(i));var r=n.message,t=n.filename,c=n.lineno,l=n.colno,s=n.error,u=n.context,f=n.timestamp,d=s&&e(s.stack,8192),p=r&&e(r,2048);!function(n,o,e){try{var r=null!=n?n:Object.keys(o);n=[];for(var t=0;t<r.length;t++){var c=r[t];o.hasOwnProperty(c)?n.push(o[c]):a.warn(c+" not configured")}n.forEach(e)}catch(n){a.error("Function failed",n)}}(o,i,(function(n){var o=(n=n.core).track,e={programmingLanguage:"JAVASCRIPT",message:null!=p?p:"trackError called without required message",stackTrace:d,lineNumber:c,lineColumn:l,fileName:t},r=function(){var n,o={},e=[],r=[],t=[],c=function(n,e){null!=e&&""!==e&&(o[n]=e)};return{add:c,addDict:function(n){for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&c(o,n[o])},addJson:function(n,o,t){var c;if(c=t)n:{if(null!=t&&(t.constructor==={}.constructor||t.constructor===[].constructor))for(var a in t)if(Object.prototype.hasOwnProperty.call(t,a)){c=!0;break n}c=!1}c&&(n={keyIfEncoded:n,keyIfNotEncoded:o,json:t},r.push(n),e.push(n))},addContextEntity:function(n){t.push(n)},getPayload:function(){return o},getJson:function(){return e},withJsonProcessor:function(o){n=o},build:function(){return null==n||n(this,r,t),o}}}();e={schema:"iglu:com.snowplowanalytics.snowplow/unstruct_event/jsonschema/1-0-0",data:{schema:"iglu:com.snowplowanalytics.snowplow/application_error/jsonschema/1-0-1",data:e}},r.add("e","ue"),r.addJson("ue_px","ue_pr",e),o.call(n,r,u,f)}))}var t,c;"function"==typeof SuppressedError&&SuppressedError,(c=t||(t={}))[c.none=0]="none",c[c.error=1]="error",c[c.warn=2]="warn",c[c.debug=3]="debug",c[c.info=4]="info";var a=function(n){return void 0===n&&(n=t.warn),{setLogLevel:function(o){n=t[o]?o:t.warn},warn:function(e,r){for(var c=[],a=2;a<arguments.length;a++)c[a-2]=arguments[a];n>=t.warn&&"undefined"!=typeof console&&(a="Snowplow: "+e,r?console.warn.apply(console,o([a+"\n",r],c,!1)):console.warn.apply(console,o([a],c,!1)))},error:function(e,r){for(var c=[],a=2;a<arguments.length;a++)c[a-2]=arguments[a];n>=t.error&&"undefined"!=typeof console&&(a="Snowplow: "+e+"\n",r?console.error.apply(console,o([a+"\n",r],c,!1)):console.error.apply(console,o([a],c,!1)))},debug:function(e){for(var r=[],c=1;c<arguments.length;c++)r[c-1]=arguments[c];n>=t.debug&&"undefined"!=typeof console&&console.debug.apply(console,o(["Snowplow: "+e],r,!1))},info:function(e){for(var r=[],c=1;c<arguments.length;c++)r[c-1]=arguments[c];n>=t.info&&"undefined"!=typeof console&&console.info.apply(console,o(["Snowplow: "+e],r,!1))}}}(),i={};n.ErrorTrackingPlugin=function(){return{activateBrowserPlugin:function(n){i[n.id]=n}}},n.enableErrorTracking=function(n,o){void 0===n&&(n={}),void 0===o&&(o=Object.keys(i));var e=n.filter,t=n.contextAdder,c=n.context;!function(n,o,e,r){n.addEventListener?n.addEventListener(o,e,r):n.attachEvent?n.attachEvent("on"+o,e):n["on"+o]=e}(window,"error",(function(n){if(e&&e&&"function"==typeof e&&e(n)||null==e){var a=o,i=c||[];t&&t&&"function"==typeof t&&(i=i.concat(t(n))),"message"in n?r({message:n.message,filename:n.filename,lineno:n.lineno,colno:n.colno,error:n.error,context:i},a):n.target&&"tagName"in n.target?(n=n.target,r({message:"Non-script error on ".concat(n.tagName," element"),filename:n.src||void 0,context:i},a)):r({message:"JS Exception. Browser doesn't support ErrorEvent API",context:i},a)}}),!0)},n.trackError=r,Object.defineProperty(n,"__esModule",{value:!0})}));
//# sourceMappingURL=index.umd.min.js.map
